<#ibiztemplate>
TARGET=PSSYSAPP
</#ibiztemplate>
<#assign bDynamicDS=false>
<#list sys.getAllPSDataEntities() as entity>
    <#if (entity.getStorageMode()==1 || entity.getStorageMode()==2) && entity.getDSLink()!='DEFAULT'>
        <#assign bDynamicDS=true>
        <#break>
    </#if>
</#list>
package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case};

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.zuul.EnableZuulProxy;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.cloud.openfeign.FeignClientsConfiguration;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import ${pub.getPKGCodeName()}.util.web.SearchContextHandlerMethodArgumentResolver;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.List;

@Slf4j
@Import({
    FeignClientsConfiguration.class
})
@EnableDiscoveryClient
@Configuration
@EnableFeignClients(basePackages = {"${pub.getPKGCodeName()}" })
@EnableZuulProxy
@ComponentScan(basePackages = {"${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}","${pub.getPKGCodeName()}.util"})
@MapperScan("${pub.getPKGCodeName()}.*.mapper")
@SpringBootApplication(exclude = {
        org.springframework.boot.autoconfigure.security.servlet.SecurityAutoConfiguration.class,
        <#--<#assign bmogo=false>-->
        <#--<#if app.getAllPSAppDataEntities()??>-->
        <#--<#list app.getAllPSAppDataEntities() as appde>-->
            <#--<#if appde.getStorageMode()?? && appde.getStorageMode()==2>-->
                <#--<#assign bmogo=true>-->
                <#--<#break >-->
            <#--</#if>-->
        <#--</#list>-->
        <#--</#if>-->
        <#--<#if bmogo==false>-->
            <#--org.springframework.boot.autoconfigure.mongo.MongoAutoConfiguration.class,-->
        <#--</#if>-->
        <#if bDynamicDS>
            com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceAutoConfigure.class
        </#if>
})
public class ${app.getPKGCodeName()}Application extends WebMvcConfigurerAdapter {

    @Autowired
    SearchContextHandlerMethodArgumentResolver resolver;

    public static void main(String[] args) {
        SpringApplication.run(${app.getPKGCodeName()}Application.class, args);
    }

    @Override
    public void addArgumentResolvers(List<HandlerMethodArgumentResolver> argumentResolvers) {
        super.addArgumentResolvers(argumentResolvers);
        argumentResolvers.add(resolver);
    }
}
