<#ibiztemplate>
TARGET=PSSYSAPP
</#ibiztemplate>
<#assign httpPort = "8080">
<#if sys.getAllPSDevSlnMSDepApps()??>
    <#list sys.getAllPSDevSlnMSDepApps() as depApp>
        <#if depApp.getPSApplication()?? && depApp.getPSApplication().codeName==item.codeName>
            <#assign httpPort = depApp.getHttpPort()?c>
            <#break>
        </#if>
    </#list>
</#if>
server:
  port: ${httpPort}
#Log配置
logging:
  level:
    ${pub.getPKGCodeName()}: info
<#if item.getAllPSAppDataEntities?? && app.getAllPSAppDataEntities()??>
#zuul网关路由设置
zuul:
  routes:
  <#assign haswfentity=false>
  <#list item.getAllPSAppDataEntities() as appDataEntity>
    <#assign serviceId="">
    <#assign serviceUrl=srfpluralize(appDataEntity.codeName?lower_case)>
    <#assign appEntity=appDataEntity.name?lower_case>
    <#assign psDataEntity=appDataEntity.getPSDataEntity()>
    <#assign systemName=sys.getCodeName()?lower_case>
    <#if psDataEntity.hasPSDEWF()?? && psDataEntity.hasPSDEWF()==true>
        <#assign haswfentity=true>
    </#if>
  <#assign sybSysServiceType=(psDataEntity.getPSSubSysServiceAPI().getServiceType())!''>
  <#comment>服务类型为中台和MASA走自身处理</#comment>
    <#if psDataEntity.getStorageMode()==4 && (sybSysServiceType!='MIDDLEPLATFORM' && sybSysServiceType!='MASA')>
        <#comment>serviceApi模式</#comment>
        <#assign serviceId=(psDataEntity.getPSSubSysServiceAPI().getServiceCodeName())!''>
        <#assign serviceUrl=srfpluralize(appDataEntity.codeName?lower_case)>
    <#else>
        <#assign sysApi=appDataEntity.getPSDEServiceAPI().getPSSysServiceAPI().codeName?lower_case>
        <#assign deApi=appDataEntity.getPSDEServiceAPI().codeName?lower_case>
        <#assign serviceId=systemName+"-"+sysApi>
    </#if>
    <#if serviceId!="">
    <#assign serviceId="$"+"{ibiz.ref.service."+serviceId?lower_case+":"+serviceId+"}">
    ${appEntity}:
      path: /${serviceUrl}/**
      serviceId: ${serviceId}
      stripPrefix: false
    </#if>
  </#list>
  <#if haswfentity==true>
    wfcore:
      path: /wfcore/**
      serviceId: ${r'${ibiz.ref.service.wf:ibzwf-api}'}
      stripPrefix: true
  </#if>
  <#if sys.getPSSystemSetting()?? && sys.getPSSystemSetting().getDataAccCtrlArch()?? && sys.getPSSystemSetting().getDataAccCtrlArch()==1>
    loginv7:
      path: /v7/login
      serviceId: ${r'${ibiz.ref.service.uaa:ibzuaa-api}'}
      stripPrefix: false
    changepwd:
      path: /v7/changepwd
      serviceId: ${r'${ibiz.ref.service.uaa:ibzuaa-api}'}
      stripPrefix: false
    uaa:
      path: /uaa/**
      serviceId: ${r'${ibiz.ref.service.uaa:ibzuaa-api}'}
      stripPrefix: false
    config:
      path: /configs/**
      serviceId: ${r'${ibiz.ref.service.uaa:ibzuaa-api}'}
      stripPrefix: false
      <#if sys.getCodeName()!='ibzou' && sys.getCodeName()!='ibzrt'>
    oucore:
      path: /ibzorganizations/**
      serviceId: ${r'${ibiz.ref.service.ou:ibzou-api}'}
      stripPrefix: false
    oudict:
      path: /dictionarys/**/Ibzou**
      serviceId: ${r'${ibiz.ref.service.ou:ibzou-api}'}
      stripPrefix: false
    ou:
      path: /ibzdepartments/**
      serviceId: ${r'${ibiz.ref.service.ou:ibzou-api}'}
      stripPrefix: false
    uaadict:
      path: /dictionarys/**/SysOperator
      serviceId: ${r'${ibiz.ref.service.uaa:ibzuaa-api}'}
      stripPrefix: false
    dict:
      path: /dictionarys/**
      serviceId: ${r'${ibiz.ref.service.dict:ibzdict-api}'}
      stripPrefix: false
    disk:
      path: /net-disk/**
      serviceId: ${r'${ibiz.ref.service.disk:ibzdisk-api}'}
      stripPrefix: false
    ou_sys_org:
      path: /sysorganizations/**
      serviceId: ${r'${ibiz.ref.service.ou:ibzou-api}'}
      stripPrefix: false
    ou_sys_dept:
      path: /sysdepartments/**
      serviceId: ${r'${ibiz.ref.service.ou:ibzou-api}'}
      stripPrefix: false
    lite-core:
      path: /lite/**
      serviceId: ${r'${ibiz.ref.service.lite:ibzlite-api}'}
      stripPrefix: false
      </#if>
  </#if>
  <#comment>通过设置该参数，避免Zuul转发请求时丢失Authorization请求头信息</#comment>
  sensitive-headers:
    - Cookie,Set-Cookie,Authorization
</#if>
