<#ibiztemplate>
TARGET=PSSUBSYSSERVICEAPIDE
</#ibiztemplate>
<#assign refDE=sys.getPSDataEntity(item.name)>
<#if refDE??>
package ${pub.getPKGCodeName()}.core.${refDE.getPSSystemModule().getCodeName()?lower_case}.client;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;
import ${pub.getPKGCodeName()}.core.${refDE.getPSSystemModule().getCodeName()?lower_case}.domain.${refDE.getCodeName()};
import ${pub.getPKGCodeName()}.core.${refDE.getPSSystemModule().getCodeName()?lower_case}.filter.${refDE.getCodeName()}SearchContext;
import org.springframework.cloud.openfeign.FeignClient;

    <#if item.getPSSubSysServiceAPI().getServicePath()?? && item.getPSSubSysServiceAPI().getServicePath() != ''>
            <#assign fullpath= item.getPSSubSysServiceAPI().getServicePath() + "/" + srfpluralize(item.getCodeName()?lower_case) >
    <#else>
        <#assign fullpath="/" + srfpluralize(item.getCodeName()?lower_case) >
    </#if>
<#comment>contextId存在下划线时，项目运行报错，模板中转中划线处理</#comment>
<#assign contextId=item.codeName?replace("_","-")>
<#if ((item.getPSSubSysServiceAPI().getServiceCodeName())!'')!=''>
    <#assign serviceId="$"+"{ibiz.ref.service."+item.getPSSubSysServiceAPI().getServiceCodeName()?lower_case+":"+item.getPSSubSysServiceAPI().getServiceCodeName()+"}">
<#else>
    <#assign serviceId="$"+"{ibiz.ref.service."+item.getPSSubSysServiceAPI().codeName?lower_case+":}">
</#if>
/**
 * 实体[${item.codeName}] 服务对象接口
 */
@FeignClient(value = "${serviceId}", contextId = "${contextId}", fallback = ${item.codeName}Fallback.class)
public interface ${item.codeName}FeignClient {

    <#if item.getPSSubSysServiceAPIDEMethods()??>
        <#list item.getPSSubSysServiceAPIDEMethods() as apiMethod>
            <#assign req_param_type=(apiMethod.getRequestParamType()!'')>
            <#assign req_param=(apiMethod.getRequestField()!'')>
            <#assign retval_type=(apiMethod.getRetvalType())!''>
            <#assign return_type='void'>
            <#if return_type?? && return_type!='' && retval_type !='VOID' && retval_type='ENTITY' ><#comment>由于无法获取到返回值类型，暂时通过请求参数类型确定返回值类型</#comment>
                <#assign return_type=item.codeName>
            </#if>
            <#if apiMethod.getActionType()=='DEACTION'><#comment>实体行为</#comment>
            <#--   ${return_type} ${srfmethodname(apiMethod.getCodeName())}(<#if req_param_type?? && req_param_type=='ENTITY'><#if apiMethod.getPSDEName()??>${apiMethod.getPSDEName()} entity</#if></#if>);  -->
                <#if apiMethod.getCodeName()?lower_case == 'get'>
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${refDE.getKeyDEField().getCodeName()?lower_case}}")
    ${refDE.codeName} get(@PathVariable("${refDE.getKeyDEField().getCodeName()?lower_case}") ${srfr7javatype(refDE.getKeyDEField().stdDataType)} ${refDE.getKeyDEField().getCodeName()?lower_case});

                <#elseif apiMethod.getCodeName()?lower_case == 'remove'>
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${refDE.getKeyDEField().getCodeName()?lower_case}}")
    Boolean remove(@PathVariable("${refDE.getKeyDEField().getCodeName()?lower_case}") ${srfr7javatype(refDE.getKeyDEField().stdDataType)} ${refDE.getKeyDEField().getCodeName()?lower_case});

    @RequestMapping(method = RequestMethod.DELETE, value = "${fullpath}/batch}")
    Boolean removeBatch(@RequestBody Collection<${srfr7javatype(refDE.getKeyDEField().stdDataType)}> idList);

                <#elseif apiMethod.getCodeName()?lower_case == 'create'>
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}")
    ${refDE.codeName} create(@RequestBody ${refDE.codeName} ${refDE.codeName?lower_case});

    @RequestMapping(method = RequestMethod.POST, value = "${fullpath}/batch")
    Boolean createBatch(@RequestBody List<${refDE.codeName}> ${srfpluralize(refDE.getCodeName()?lower_case)});

                <#elseif apiMethod.getCodeName()?lower_case == 'save'>
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/save")
    Boolean save(@RequestBody ${refDE.codeName} ${refDE.codeName?lower_case});

    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/savebatch")
    Boolean saveBatch(@RequestBody List<${refDE.codeName}> ${srfpluralize(refDE.getCodeName()?lower_case)});

                <#elseif apiMethod.getCodeName()?lower_case == 'getdraft'>
    @RequestMapping(method = RequestMethod.GET, value = "${fullpath}/getdraft")
    ${refDE.codeName} getDraft();

                <#elseif apiMethod.getCodeName()?lower_case == 'checkkey'>
    @RequestMapping(method = RequestMethod.POST, value = "${fullpath}/checkkey")
    Boolean checkKey(@RequestBody ${refDE.codeName} ${refDE.codeName?lower_case});

                <#elseif apiMethod.getCodeName()?lower_case == 'update'>
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${refDE.getKeyDEField().getCodeName()?lower_case}}")
    ${refDE.codeName} update(@PathVariable("${refDE.getKeyDEField().getCodeName()?lower_case}") ${srfr7javatype(refDE.getKeyDEField().stdDataType)} ${refDE.getKeyDEField().getCodeName()?lower_case},@RequestBody ${refDE.codeName} ${refDE.codeName?lower_case});

    @RequestMapping(method = RequestMethod.PUT, value = "${fullpath}/batch")
    Boolean updateBatch(@RequestBody List<${refDE.codeName}> ${srfpluralize(refDE.getCodeName()?lower_case)});

                <#elseif apiMethod.getCodeName()?lower_case == 'createbatch'>
                <#elseif apiMethod.getCodeName()?lower_case == 'updatebatch'>
                <#elseif apiMethod.getCodeName()?lower_case == 'removebatch'>
                <#elseif apiMethod.getCodeName()?lower_case == 'savebatch'>
                <#else>
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/{${refDE.getKeyDEField().getCodeName()?lower_case}}/${apiMethod.getCodeName()?lower_case}")
    ${refDE.codeName} ${apiMethod.getCodeName()?uncap_first}(@PathVariable("${refDE.getKeyDEField().getCodeName()?lower_case}") ${srfr7javatype(refDE.getKeyDEField().stdDataType)} ${refDE.getKeyDEField().getCodeName()?lower_case},@RequestBody ${refDE.codeName} ${refDE.codeName?lower_case});

                </#if>
            <#elseif apiMethod.getActionType()=='SELECT'><#comment>简单查询</#comment>
            <#--   List<${item.codeName}> ${srfmethodname(apiMethod.getCodeName())}(<#if req_param_type?? && req_param_type=='ENTITY'><#if apiMethod.getPSDEName()??>${apiMethod.getPSDEName()} entity</#if></#if>);  -->
    @RequestMapping(method = RequestMethod.<#if apiMethod.getRequestMethod()??>${apiMethod.getRequestMethod()}<#else>POST</#if>, value = "${fullpath}/${apiMethod.getCodeName()?lower_case}")
    Page<${refDE.codeName}> ${apiMethod.getCodeName()?uncap_first}();

            <#elseif apiMethod.getActionType()=='FETCH'><#comment>数据集合</#comment>

    @RequestMapping(method = RequestMethod.POST, value = "${fullpath}/${apiMethod.getCodeName()?lower_case?replace("fetch","search")}")
    Page<${refDE.codeName}> ${apiMethod.getCodeName()?uncap_first?replace("fetch","search")}(@RequestBody ${refDE.getCodeName()}SearchContext context);

            <#elseif apiMethod.getActionType()=='USER'><#comment>用户自定义</#comment>
    void ${apiMethod.getCodeName()?uncap_first}();

            </#if>

        </#list>
    </#if>
}
</#if>
