<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#comment>索引从实体</#comment>
<#assign isIndexSubDE=false>
<#if de.getMinorPSDERs()??>
<#comment>判断当前实体是否为索引子实体或继承子实体</#comment>
<#assign isIndexSubDE=false>
<#if de.getMinorPSDERs()??>
    <#list de.getMinorPSDERs() as MinorPSDER>
        <#if MinorPSDER.getDERType()?? && MinorPSDER.getMajorPSDataEntity()??>
            <#comment>继承关系、索引关系 (包含分组属性)</#comment>
            <#if MinorPSDER.getDERType()=="DERINHERIT" || (MinorPSDER.getDERType()=="DERINDEX" ) && MinorPSDER.getMajorPSDataEntity().getIndexTypePSDEField()??>
                <#assign isIndexSubDE=true>
                <#assign indexPSDER=MinorPSDER>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>
<#if isIndexSubDE  && indexPSDER??>

<#comment>索引主实体</#comment>
<#assign majorIndexDE=indexPSDER.getMajorPSDataEntity()>
<#assign majorIndexDECodeName=indexPSDER.getMajorPSDataEntity().codeName>
<#assign majorIndexDECodeNameCamel = srfcaseformat(majorIndexDECodeName,'l_u2lC')?cap_first>
<#assign majorIndexDEKeyFieldCodeName=srfcaseformat(majorIndexDE.getKeyPSDEField().codeName,'l_u2lC')>
<#assign majorIndexDEMajorTextFieldCodeName=srfcaseformat(majorIndexDE.getMajorPSDEField().codeName,'l_u2lC')>
<#assign MinorIndexDECodeName=de.codeName>
<#assign MinorIndexDECodeNameCamel = srfcaseformat(MinorIndexDECodeName,'l_u2lC')?cap_first>
<#assign MinorIndexDEKeyFieldCodeName=srfcaseformat(de.getKeyPSDEField().codeName,'l_u2lC')>
<#assign MinorIndexDEMajorTextFieldCodeName=srfcaseformat(de.getMajorPSDEField().codeName,'l_u2lC')>

package ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().codeName?lower_case}.mapping;

import org.mapstruct.*;
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.codeName};
import ${pub.getPKGCodeName()}.core.${majorIndexDE.getPSSystemModule().getCodeName()?lower_case}.domain.${majorIndexDE.codeName};
import java.util.List;

@Mapper(componentModel = "spring", uses = {})
public interface ${de.codeName}InheritMapping {

    @Mappings({
        @Mapping(source ="${MinorIndexDEKeyFieldCodeName}",target = "${majorIndexDEKeyFieldCodeName}"),
        @Mapping(source ="${MinorIndexDEMajorTextFieldCodeName}",target = "${majorIndexDEMajorTextFieldCodeName}"),
        @Mapping(target ="focusNull",ignore = true),
        <#if indexPSDER.getPSDERIndexDEFieldMaps?? && indexPSDER.getPSDERIndexDEFieldMaps()??>
        <#list indexPSDER.getPSDERIndexDEFieldMaps() as indexFieldmapping>
            <#comment>排除主键及主文本属性</#comment>
            <#if indexFieldmapping.getMajorPSDEField()?? && indexFieldmapping.getMinorPSDEField()??>
                <#assign majorDEField=indexFieldmapping.getMajorPSDEField()>
                <#assign MinorDEField=indexFieldmapping.getMinorPSDEField()>
                <#if majorDEField.isKeyDEField()==false && MinorDEField.isKeyDEField()==false && majorDEField.isMajorDEField()==false && MinorDEField.isMajorDEField()==false>
                    <#if !P.exists(MinorDEField.codeName,majorDEField.codeName)>
        @Mapping(source ="${srfcaseformat(MinorDEField.codeName,'l_u2lC')}",target = "${srfcaseformat(majorDEField.codeName,'l_u2lC')}"),
                    </#if>
                </#if>
            </#if>
        </#list>
        </#if>
    })
    ${majorIndexDECodeName} to${majorIndexDECodeNameCamel}(${MinorIndexDECodeName} ${MinorIndexDECodeName?lower_case});

    @Mappings({
        @Mapping(source ="${majorIndexDEKeyFieldCodeName}" ,target = "${MinorIndexDEKeyFieldCodeName}"),
        @Mapping(source ="${majorIndexDEMajorTextFieldCodeName}" ,target = "${MinorIndexDEMajorTextFieldCodeName}"),
        @Mapping(target ="focusNull",ignore = true),
        <#if indexPSDER.getPSDERIndexDEFieldMaps()??>
        <#list indexPSDER.getPSDERIndexDEFieldMaps() as indexFieldmapping>
            <#comment>排除主键及主文本属性</#comment>
            <#if indexFieldmapping.getMajorPSDEField()?? && indexFieldmapping.getMinorPSDEField()??>
                <#assign majorDEField=indexFieldmapping.getMajorPSDEField()>
                <#assign MinorDEField=indexFieldmapping.getMinorPSDEField()>
                <#if majorDEField.isKeyDEField()==false && MinorDEField.isKeyDEField()==false && majorDEField.isMajorDEField()==false && MinorDEField.isMajorDEField()==false>
                    <#if !P.exists(majorDEField.codeName,MinorDEField.codeName)>
        @Mapping(source ="${srfcaseformat(majorDEField.codeName,'l_u2lC')}",target = "${srfcaseformat(MinorDEField.codeName,'l_u2lC')}"),
                    </#if>
                </#if>
            </#if>
        </#list>
        </#if>
    })
    ${MinorIndexDECodeName} to${MinorIndexDECodeNameCamel}(${majorIndexDECodeName} ${majorIndexDECodeName?lower_case});

    List<${majorIndexDECodeName}> to${majorIndexDECodeNameCamel}(List<${MinorIndexDECodeName}> ${MinorIndexDECodeName?lower_case});

    List<${MinorIndexDECodeName}> to${MinorIndexDECodeNameCamel}(List<${majorIndexDECodeName}> ${majorIndexDECodeName?lower_case});

}
</#if>
</#if>


