<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
<#comment>判断当前实体是否包含自定义行为</#comment>
<#assign hasServiceEx=false>
<#if item.getAllPSDEActions()??>
    <#list item.getAllPSDEActions() as deaction>
        <#if deaction.isEnableBackend() && deaction.getActionType()=='USERCUSTOM'>
            <#assign hasServiceEx=true>
            <#break>
        <#elseif deaction.isEnableBackend() && deaction.getTestActionMode?? && deaction.getTestActionMode()?? && (deaction.getTestActionMode() ==1 || deaction.getTestActionMode() ==3)>
            <#assign hasServiceEx=true>
            <#break>
        </#if>
    </#list>
</#if>
<#if hasServiceEx && (de.getStorageMode()==1 || de.getStorageMode()==2 ||de.getStorageMode()==4||de.getStorageMode()==0 ) >
package ${pub.getPKGCodeName()}.core.extensions.service;

import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.impl.${item.codeName}ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.domain.${item.codeName};
import org.springframework.stereotype.Service;
<#if pub.isEnableGlobalTransaction?? && pub.isEnableGlobalTransaction()?? && pub.isEnableGlobalTransaction()==true>
import io.seata.spring.annotation.GlobalTransactional;
</#if>
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Primary;
import java.util.*;

/**
 * 实体[${item.getLogicName()}] 自定义服务对象
 */
@Slf4j
@Primary
@Service("${item.codeName}ExService")
public class ${item.codeName}ExService extends ${item.codeName}ServiceImpl {

    <#assign keyfield=de.getKeyPSDEField()>

    <#comment>SQL存储：解决mybatis继承service批操作报错</#comment>
    <#if de.getStorageMode()==1>
    @Override
    protected Class currentModelClass() {
        return com.baomidou.mybatisplus.core.toolkit.ReflectionKit.getSuperClassGenericType(this.getClass().getSuperclass(), 1);
    }
    </#if>

    <#comment>输出实体行为</#comment>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.isEnableBackend()>
                <#if deaction.getActionType()=='USERCUSTOM'>
                <#assign actionAnno="["+deaction.getCodeName()+"] 行为扩展">
                <#if ((deaction.getLogicName())!'')!=''>
                    <#assign actionAnno="["+deaction.getCodeName()+":"+deaction.getLogicName()+"] 行为扩展">
                </#if>
                <#if ((deaction.getMemo())!'')!=''>
                    <#assign actionAnno=actionAnno+"："+deaction.getMemo()>
                </#if>
    /**
     * ${actionAnno}
     * @param et
     * @return
     */
    @Override
    <@transactionalAnno deaction/>
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} et) {
        return super.${srfmethodname(deaction.getCodeName())}(et);
    }
                </#if>
                <#comment>输出测试行为</#comment>
                <@outputTestActionDetail deaction />
            </#if>
        </#list>
    </#if>
}
</#if>

<#comment>输出测试行为</#comment>
<#macro outputTestActionDetail deaction>
    <#if deaction.isEnableBackend() && deaction.getTestActionMode?? && deaction.getTestActionMode()??>
        <#if deaction.getTestActionMode() ==1 || deaction.getTestActionMode() ==3>
            <#if (deaction.getActionType()=='USERCUSTOM')>
    @Override
    public boolean test${srfmethodname(deaction.getCodeName())?cap_first}(${item.getCodeName()} et) {
        return super.test${srfmethodname(deaction.getCodeName())?cap_first}(et);
    }

            <#elseif deaction.getActionType()=='DELOGIC'>
    @Override
    public boolean test${srfmethodname(deaction.getCodeName())?cap_first}(${item.getCodeName()} et) {
         return super.test${srfmethodname(deaction.getCodeName())?cap_first}(et);
    }

            <#elseif deaction.getCodeName()?lower_case == 'get'>
    @Override
    public boolean testGet(${srfr7javatype(keyfield.stdDataType)} key) {
        return super.testGet(key);
    }

            <#elseif deaction.getCodeName()?lower_case == "createbatch">
            <#elseif deaction.getCodeName()?lower_case == "updatebatch">
            <#elseif deaction.getCodeName()?lower_case == "removebatch">
            <#elseif deaction.getCodeName()?lower_case == "savebatch">
            <#elseif deaction.getCodeName()?lower_case == "create">
    @Override
    public boolean testCreate(${item.getCodeName()} et) {
        return super.testCreate(et);
    }

    @Override
    public boolean testCreateBatch(List<${item.getCodeName()}> list) {
        return super.testCreateBatch(list);
    }

            <#elseif deaction.getCodeName()?lower_case == "update">
    @Override
    public boolean testUpdate(${item.getCodeName()} et) {
         return super.testUpdate(et);
    }

    @Override
    public boolean testUpdateBatch(List<${item.getCodeName()}> list) {
        return super.testUpdateBatch(list);
    }

            <#elseif deaction.getCodeName()?lower_case == "save">
    @Override
    public boolean testSave(${item.getCodeName()} et) {
        return super.testSave(et);
    }

    @Override
    public boolean testSaveOrUpdate(${item.getCodeName()} et) {
        return super.testSaveOrUpdate(et);
    }

    @Override
    public boolean testSaveBatch(Collection<${item.getCodeName()}> list) {
        return super.testSaveBatch(list);
    }

    @Override
    public boolean testSaveBatch(List<${item.getCodeName()}> list) {
        return super.testSaveBatch(list);
    }

            <#elseif deaction.getCodeName()?lower_case == "remove">
    @Override
    public boolean testRemove(${srfr7javatype(keyfield.stdDataType)} key) {
        return super.testRemove(key);
    }

    @Override
    public boolean testRemoveBatch(Collection<${srfr7javatype(keyfield.stdDataType)}> idList) {
        return super.testRemoveBatch(idList);
    }

            <#elseif deaction.getCodeName()?lower_case == "getdraft">
    @Override
    public boolean testGetDraft(${item.getCodeName()} et) {
        return super.testGetDraft(et);
    }

            <#elseif deaction.getCodeName()?lower_case == "checkkey">
    @Override
    public boolean testCheckKey(${item.getCodeName()} et) {
        return super.testCheckKey(et);
    }

            <#else>
    @Override
    public boolean test${srfmethodname(deaction.getCodeName())?cap_first}(${item.getCodeName()} et) {
        return super.test${srfmethodname(deaction.getCodeName())?cap_first}(et);
    }

            </#if>
        </#if>
    </#if>
</#macro>

<#comment>事务注解</#comment>
<#macro transactionalAnno deaction>
    <#if deaction.getTransactionMode?? && deaction.getTransactionMode()??>
        <#if deaction.getTransactionMode()=='GLOBAL'>
    @GlobalTransactional
        <#elseif deaction.getTransactionMode()=='DEFAULT'>
    @Transactional
        </#if>
    </#if>
</#macro>


