<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<#if pub.isEnableGlobalTransaction?? && pub.isEnableGlobalTransaction()?? && pub.isEnableGlobalTransaction()==true>
<?xml version="1.1" encoding="UTF-8" standalone="no"?>
<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog" xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.9.xsd">
    <changeSet author="Think (generated)" id="1595929877142-2">
        <preConditions onFail="MARK_RAN"  >
            <not>
                <tableExists tableName="undo_log" />
            </not>
        </preConditions>
        <createTable remarks="AT transaction mode undo table" tableName="undo_log">
            <column name="branch_id" remarks="branch transaction id" type="BIGINT">
                <constraints nullable="false"/>
            </column>
            <column name="xid" remarks="global transaction id" type="VARCHAR(100)">
                <constraints nullable="false"/>
            </column>
            <column name="context" remarks="undo_log context,such as serialization" type="VARCHAR(128)">
                <constraints nullable="false"/>
            </column>
            <column name="rollback_info" remarks="rollback info" type="LONGBLOB">
                <constraints nullable="false"/>
            </column>
            <column name="log_status" remarks="0:normal status,1:defense status" type="INT">
                <constraints nullable="false"/>
            </column>
            <column name="log_created" remarks="create datetime" type="datetime">
                <constraints nullable="false"/>
            </column>
            <column name="log_modified" remarks="modify datetime" type="datetime">
                <constraints nullable="false"/>
            </column>
        </createTable>
        <addUniqueConstraint columnNames="xid, branch_id" constraintName="ux_undo_log" tableName="undo_log"/>
    </changeSet>
</databaseChangeLog>
</#if>
