<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
    {
    "systemid":"${sys.codeName}",
    "unires":[
       <#if sys.getAllPSSysUniReses()??>
       <#list sys.getAllPSSysUniReses() as unires>
        <#if unires_index gt 0>,</#if>
       {
            "unirescode":"${unires.getResCode()}",
            "uniresname":"${unires.getName()}"
       }
       </#list>
       </#if>
    ],
    <#if sys.getAllPSDataEntities()??>
    <#assign ct=0>
    "entities":[
        <#list sys.getAllPSDataEntities() as de>
            <#if de.getAllPSDEServiceAPIs?? && de.getAllPSDEServiceAPIs()??>
                <#assign hasDEApi=false>
                <#list de.getAllPSDEServiceAPIs() as deapi>
                    <#assign hasDEApi=true>
                    <#break>
                </#list>
                <#if hasDEApi>
                    <#if !P.exists(de.getCodeName(),"")>
                        <#if (ct>0)>
    ,</#if><#assign ct=ct+1>
                        <#assign dataSetResult=getDataSet(de)>
                        <#assign deActionResult=getDEAction(de)>
    {
    "dename":"${de.codeName}",
    "delogicname":"${de.logicName}",
    "sysmoudle":{"id":"${de.getPSSystemModule().codeName?upper_case}","name":"${de.getPSSystemModule().name}"},
    "dedataset":${dataSetResult},
    "deaction":${deActionResult},
    "datascope":${getDataScope(de)}
    }
                    </#if>
                </#if>
            </#if>
        </#list>
    ],
    </#if>
    <#if sys.getAllPSApps()??>
    "appmenus":[
        <#list sys.getAllPSApps() as app>
            <#if app_index gt 0 >,</#if>
            {
               <#assign appmenu=getAppMenu(app)>
               "appid":"${app.codeName}",
               "appname":"${app.name}",
               "appmenu":${appmenu}
            }
        </#list>
            ]
    </#if>
    }
<#comment>获取实体数据集</#comment>
<#function getDataSet de>
    <#assign result_dataSet="[" >
    <#if de.getAllPSDEDataSets()??>
        <#list de.getAllPSDEDataSets() as dataSet>
            <#if dataSet_index gt 0><#assign result_dataSet=result_dataSet+","></#if>
            <#assign dataSetLogicName="">
            <#if dataSet.getLogicName()?? && dataSet.getLogicName()!=''><#assign dataSetLogicName=dataSet.getLogicName()><#else><#assign dataSetLogicName=dataSet.codeName></#if>
            <#assign result_dataSet=result_dataSet+"{\"id\":\""+dataSet.codeName+"\" , \"name\":\""+dataSetLogicName+"\"}">
        </#list>
    </#if>
    <#assign result_dataSet=result_dataSet+"]" >
    <#return result_dataSet>
</#function>

<#comment>获取实体行为</#comment>
<#function getDEAction de>
    <#assign result_deAction="[" >
    <#if de.getAllPSDEActions()??>
        <#list de.getAllPSDEActions() as deAction>
            <#if deAction_index gt 0><#assign result_deAction=result_deAction+","></#if>
            <#assign deActionLogicName="">
            <#if deAction.getLogicName()?? && deAction.getLogicName()!=''><#assign deActionLogicName=deAction.getLogicName()><#else><#assign deActionLogicName=deAction.codeName></#if>
            <#assign result_deAction=result_deAction+"{\"id\":\""+deAction.codeName+"\" , \"name\":\""+deActionLogicName+"\" , \"type\":\""+deAction.getActionType()+"\" }">
        </#list>
    </#if>
    <#assign result_deAction=result_deAction+"]" >
    <#return result_deAction>
</#function>


<#comment>获取统一资源</#comment>
<#function getUniRes>
    <#assign result_unires="[" >
    <#if de.getAllPSDEActions()??>
        <#list de.getAllPSDEActions() as deAction>
            <#if deAction_index gt 0><#assign result_unires=result_unires+","></#if>
            <#assign deActionLogicName="">
            <#if deAction.getLogicName()?? && deAction.getLogicName()!=''><#assign deActionLogicName=deAction.getLogicName()><#else><#assign deActionLogicName=deAction.codeName></#if>
            <#assign result_unires=result_unires+"{\"id\":\""+deAction.codeName+"\" , \"name\":\""+deActionLogicName+"\" , \"type\":\""+deAction.getActionType()+"\" }">
        </#list>
    </#if>
    <#assign result_unires=result_unires+"]" >
    <#return result_unires>
</#function>

<#comment>获取应用菜单</#comment>
<#function getAppMenu app>
    <#assign result_appMenu="[">
    <#if app.getAllPSAppMenuModels()??>
        <#list app.getAllPSAppMenuModels() as appMenu>
            <#if appMenu_index gt 0><#assign result_appMenu=result_appMenu+","></#if>
            <#assign menuItems=getAppMenuItems(appMenu)>
            <#assign result_appMenu=result_appMenu+"{\"menuid\":\""+appMenu.codeName+"\", \"menuname\":\""+appMenu.name+"\", \"menuitem\":"+menuItems+" }">
        </#list>
    </#if>
    <#assign result_appMenu=result_appMenu+"]">
    <#return result_appMenu>
</#function>

<#comment>获取菜单项集合</#comment>
<#function getAppMenuItems menuGroup>
    <#assign result_MenuItems="[" >
    <#if menuGroup.getPSAppMenuItems()??>
        <#list menuGroup.getPSAppMenuItems() as appMenuItem>
            <#assign singMenuItem="">
            <#if appMenuItem.getPSAppMenuItems()??>
                <#assign result_MenuItems=result_MenuItems+"{ \"id\":\""+appMenuItem.name+"\" , \"name\":\""+appMenuItem.getCaption()+"\" , \"items\":"+getAppMenuItems(appMenuItem)+"}">
            <#else>
                <#assign result_MenuItems=result_MenuItems+"{ \"id\":\""+appMenuItem.name+"\" , \"name\":\""+appMenuItem.getCaption()+"\" }">
            </#if>
            <#if appMenuItem_has_next>
                <#assign result_MenuItems=result_MenuItems+",">
            </#if>
        </#list>
    </#if>
    <#assign result_MenuItems=result_MenuItems+"]" >
    <#return result_MenuItems>
</#function>


<#comment>获取数据范围</#comment>
<#function getDataScope de>
<#assign result_DataScope="[">
    <#assign result_DataScope=result_DataScope+"{\"id\":\"all\",\"name\":\"全部数据\"}">
    <#if de.getPSDEFieldByPDT('ORGID',true)?? >
        <#assign result_DataScope=result_DataScope+", {\"id\":\"curorg\",\"name\":\"当前单位\"},{\"id\":\"porg\",\"name\":\"上级单位\"},{\"id\":\"sorg\",\"name\":\"下级单位\"} ">
    </#if>
    <#if  de.getPSDEFieldByPDT('ORGSECTORID',true)?? >
        <#assign result_DataScope=result_DataScope+", {\"id\":\"curorgdept\",\"name\":\"当前部门\"},{\"id\":\"porgdept\",\"name\":\"上级部门\"},{\"id\":\"sorgdept\",\"name\":\"下级部门\"} ">
    </#if>
    <#if  de.getPSDEFieldByPDT('CREATEMAN',true)??>
        <#assign result_DataScope=result_DataScope+", {\"id\":\"createman\",\"name\":\"创建人\"}">
    </#if>
<#assign result_DataScope=result_DataScope+"]">
<#return result_DataScope>
</#function>



