<#ibiztemplate>
TARGET=PSDESERVICEAPI
</#ibiztemplate>
<#comment>不发布子系统实体</#comment>
<#if de.isSubSysDE()==false>
    <#assign pubPkgCodeName = pub.getPKGCodeName()>
    <#assign itemSysApiCodeNameLC = item.getPSSysServiceAPI().getCodeName()?lower_case>
    <#assign dtoBase="DTOBase">
    <#comment>中台模式通过DTOClient设置dirtyflag</#comment>
    <#if ((de.getPSSubSysServiceAPI().getServiceType())!'')=='MIDDLEPLATFORM'>
        <#assign dtoBase="DTOClient">
    </#if>
    <#assign hasValueRuleGroup=false>
    <#if sys.codeName == 'Sample'>
        <#if de.getAllPSDEFValueRules()??>
            <#list de.getAllPSDEFValueRules() as deRule>
                <#if deRule.codeName!='Default'>
                    <#if deRule.getPSDEFVRGroupCondition()??>
                        <#assign hasValueRuleGroup=true>
                        <#break>
                    </#if>
                </#if>
            </#list>
        </#if>
    </#if>
package ${pubPkgCodeName}.${itemSysApiCodeNameLC}.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.alibaba.fastjson.annotation.JSONField;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import ${pub.getPKGCodeName()}.util.domain.DTOBase;
import ${pub.getPKGCodeName()}.util.domain.DTOClient;
import lombok.Data;
<#if hasValueRuleGroup>
import ${pub.getPKGCodeName()}.util.annotation.ValueRuleCheck;
</#if>

/**
 * 服务DTO对象[${item.getCodeName()}DTO]
 */
@Data
<@valueRuleGroup/>
public class ${item.getCodeName()}DTO extends ${dtoBase} implements Serializable {

	private static final long serialVersionUID = 1L;

    <#if item.getPSDEServiceAPIFields()??>
        <#comment>接口属性集合</#comment>
        <#list item.getPSDEServiceAPIFields() as apifield>
            <#assign defDataType = (apifield.getPSDEField().getDataType())!"">
            <#assign columnname = apifield.getName()?lower_case>
            <#assign prvateCodeName = srfcaseformat(apifield.getCodeName(),'l_u2lC') >
            <#assign publicCodeName = prvateCodeName?cap_first >
            <#assign jsonfield = apifield.getCodeName()?lower_case >
            <#assign defield=(apifield.getPSDEField())!"">
            <#if defDataType!='ONE2MANYDATA'>
    /**
     * 属性 [${apifield.getName()}]
     *
     */
            <#if defDataType == "DATETIME" || ((defDataType=='PICKUPDATA'||defDataType=='INHERIT') && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td %1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "${jsonfield}" , format="yyyy-MM-dd HH:mm:ss")
            <#elseif defDataType == "DATE" || ((defDataType=='PICKUPDATA'||defDataType=='INHERIT') && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td")>
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "${jsonfield}" , format="yyyy-MM-dd")
            <#elseif defDataType == "TIME" || ((defDataType=='PICKUPDATA'||defDataType=='INHERIT') && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "${jsonfield}" , format="HH:mm:ss")
            <#else>
    @JSONField(name = "${jsonfield}")
            </#if>
    @JsonProperty("${jsonfield}")
    <#comment>Long型数据转String,解决前端精度丢失问题</#comment>
    <#if srfr7javatype(apifield.getStdDataType())=='Long'>
    @JsonSerialize(using = ToStringSerializer.class)
    </#if>
    <@valueRule defield />
    private ${srfr7javatype(apifield.getStdDataType())} ${prvateCodeName};

            </#if>
        </#list>
    </#if>

    <#comment>输出set方法用于设置null值</#comment>
    <#list item.getPSDEServiceAPIFields() as apifield>
        <#assign defield = apifield.getPSDEField() >
        <#assign defDataType = (defield.getDataType())!"">
        <#assign columnname = apifield.getName()?lower_case>
        <#assign prvateCodeName = srfcaseformat(apifield.getCodeName(),'l_u2lC') >
        <#assign publicCodeName = prvateCodeName?cap_first >
        <#if defield.isPhisicalDEField()==true && defield.isKeyDEField()==false  && defDataType!='ONE2MANYDATA'>
            <#if defield.getPredefinedType()?? && defield.getPredefinedType()!=''>
            <#else >
    /**
     * 设置 [${apifield.getName()}]
     */
    public void set${publicCodeName}(${srfr7javatype(apifield.getStdDataType())}  ${prvateCodeName}){
        this.${prvateCodeName} = ${prvateCodeName} ;
        this.modify("${columnname}",${prvateCodeName});
    }

            </#if>
        </#if>
    </#list>

    <#comment>输出关系数据（子实体）</#comment>
    <#if item.getPSDEServiceAPIRSs()?? >
        <#list item.getPSDEServiceAPIRSs() as apider>
        <#if apider.getPSDER1N()??>
            <#assign der = apider.getPSDER1N() >
            <#if apider.getMinorPSDEServiceAPI().isNested()>
                <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
                <#assign subcode = srfcaseformat((der.getMinorCodeName()!der.getMinorPSDataEntity().getCodeName()),'l_u2lC') >
                <#if subcode?? && subcode==''><#assign subcode=srfcaseformat(der.getMinorPSDataEntity().getCodeName(),'l_u2lC')></#if>
    /**
     *  [${apider.getMinorPSDEServiceAPI().getName()}]
     */
    @JsonProperty("${subDTOs}")
    @JSONField(name = "${subDTOs}")
	private List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subcode} ;

            </#if>
        </#if>
        </#list>
    </#if>
}

</#if>

<#comment>属性值规则</#comment>
<#macro valueRule defield>
<#if defield !=''>
    <#if defield.isKeyDEField()==true || defield.getPredefinedType()?? && defield.getPredefinedType()!=''>
    <#else>
        <#if defield.isAllowEmpty()==false>
            <#assign notNullMsg="["+defield.getLogicName()+"]不允许为空!">
            <#if srfr7javatype(defield.stdDataType)=='String'>
    @NotBlank(message = "${notNullMsg}")
            <#else>
    @NotNull(message = "${notNullMsg}")
            </#if>
        </#if>
    </#if>
    <#if defield.getAllPSDEFValueRules()??>
        <#list defield.getAllPSDEFValueRules() as defieldVR>
            <#if defieldVR.getPSDEFVRGroupCondition?? && defieldVR.getPSDEFVRGroupCondition()?? && defieldVR.getCodeName()=='Default'>
                <#assign vrCond=defieldVR.getPSDEFVRGroupCondition()>
                <#assign vrCondType=vrCond.getCondType()>
                <#assign vrCondOp=vrCond.getCondOp()>
                <#if vrCond.getPSDEFVRConditions?? && vrCond.getPSDEFVRConditions()??>
                    <#list vrCond.getPSDEFVRConditions() as subVRCond>
                        <#if subVRCond.getCondType()=='STRINGLENGTH'>
                            <#if subVRCond.getMaxValue()?c!='-1'>
    @Size(min = 0, max = ${subVRCond.getMaxValue()?c}, message = "${subVRCond.getRuleInfo()}")
                            </#if>
                        </#if>
                    </#list>
                </#if>
            </#if>
        </#list>
    </#if>
</#if>
</#macro>

<#comment>属性值规则(规则组)</#comment>
<#macro valueRuleGroup>
    <#if hasValueRuleGroup>
        <#assign ruleMsg="">
@ValueRuleCheck.List({
        <#list de.getAllPSDEFValueRules() as deRule>
            <#if deRule.codeName!='Default'>
                <#if deRule.getPSDEFVRGroupCondition()??>
                    <#assign ruleName=(de.codeName+"_"+deRule.getPSDEField().codeName+"_"+deRule.codeName)?lower_case>
                    <#assign ruleField=(deRule.getPSDEField().codeName)?lower_case>
                    <#assign group=deRule.getPSDEFVRGroupCondition()>
        @ValueRuleCheck(field = "${ruleField}", rule = "${ruleName}"),
                </#if>
            </#if>
        </#list>
})
    </#if>
</#macro>